<?php

declare(strict_types=1);

namespace Imi\Cli\Annotation;

use Imi\Bean\Annotation\Base;
use Imi\Bean\Annotation\Parser;

/**
 * 命令行注解.
 *
 * @Annotation
 *
 * @Target("CLASS")
 *
 * @Parser("Imi\Cli\Parser\ToolParser")
 *
 * @property string|null $name      命令行名称
 * @property string      $separator 命令名分割符
 */
#[\Attribute(\Attribute::TARGET_CLASS | \Attribute::IS_REPEATABLE)]
class Command extends Base
{
    /**
     * {@inheritDoc}
     */
    protected ?string $defaultFieldName = 'name';

    public function __construct(?array $__data = null, ?string $name = null, string $separator = '/')
    {
        parent::__construct(...\func_get_args());
    }
}
