<?php

declare(strict_types=1);

namespace Imi\Validate\Annotation;

use Imi\Bean\Annotation;

/**
 * 列表验证
 *
 * @Annotation
 *
 * @Target({"CLASS", "METHOD", "PROPERTY"})
 *
 * @property array $list 列表
 */
#[\Attribute(\Attribute::TARGET_CLASS | \Attribute::TARGET_METHOD | \Attribute::TARGET_PROPERTY | \Attribute::IS_REPEATABLE)]
class InList extends Condition
{
    /**
     * @param callable $callable
     */
    public function __construct(?array $__data = null, ?string $name = null, bool $optional = false, $default = null, bool $inverseResult = false, string $message = '{name} validate failed', $callable = '\Imi\Validate\ValidatorHelper::in', array $args = [
        '{:value}',
        '{list}',
    ], ?string $exception = null, ?int $exCode = null, array $list = [])
    {
        parent::__construct(...\func_get_args());
    }
}
