<?php

declare(strict_types=1);

namespace Imi\Validate\Annotation;

use Imi\Bean\Annotation;

/**
 * 正则验证
 *
 * @Annotation
 *
 * @Target({"CLASS", "METHOD", "PROPERTY"})
 *
 * @property string $pattern 正则表达式文本
 */
#[\Attribute(\Attribute::TARGET_CLASS | \Attribute::TARGET_METHOD | \Attribute::TARGET_PROPERTY | \Attribute::IS_REPEATABLE)]
class Regex extends Condition
{
    /**
     * @param callable $callable
     */
    public function __construct(?array $__data = null, ?string $name = null, bool $optional = false, $default = null, bool $inverseResult = false, string $message = '{name} validate failed', $callable = '\Imi\Validate\ValidatorHelper::regex', array $args = [
        '{:value}',
        '{pattern}',
    ], ?string $exception = null, ?int $exCode = null, string $pattern = '')
    {
        parent::__construct(...\func_get_args());
    }
}
